function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

import React from 'react';
import IconSettings from "../../../../components/icon-settings";
import Button from "../../../../components/button"; // `~` is replaced with design-system-react at runtime

import Card from "../../../../components/card";
import CardEmpty from "../../../../components/card/empty";
import CardFilter from "../../../../components/card/filter";
import DataTable from "../../../../components/data-table";
import DataTableColumn from "../../../../components/data-table/column";
import Icon from "../../../../components/icon";
var sampleItems = [{
  name: 'Cloudhub'
}, {
  name: 'Cloudhub + Anypoint Connectors'
}, {
  name: 'Cloud City'
}];

var Example =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Example, _React$Component);

  function Example() {
    var _ref;

    var _temp, _this;

    _classCallCheck(this, Example);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _possibleConstructorReturn(_this, (_temp = _this = _possibleConstructorReturn(this, (_ref = Example.__proto__ || Object.getPrototypeOf(Example)).call.apply(_ref, [this].concat(args))), Object.defineProperty(_assertThisInitialized(_this), "state", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: {
        items: sampleItems,
        isFiltering: false
      }
    }), Object.defineProperty(_assertThisInitialized(_this), "handleFilterChange", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value(event) {
        var filteredItems = sampleItems.filter(function (item) {
          return RegExp(event.target.value, 'i').test(item.name);
        });

        _this.setState({
          isFiltering: true,
          items: filteredItems
        });
      }
    }), Object.defineProperty(_assertThisInitialized(_this), "handleDeleteAllItems", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value() {
        _this.setState({
          isFiltering: false,
          items: []
        });
      }
    }), Object.defineProperty(_assertThisInitialized(_this), "handleAddItem", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value() {
        _this.setState({
          items: sampleItems
        });
      }
    }), _temp));
  }

  _createClass(Example, [{
    key: "render",
    value: function render() {
      var isEmpty = this.state.items.length === 0;
      return React.createElement(IconSettings, {
        iconPath: "/assets/icons"
      }, React.createElement("div", {
        className: "slds-grid slds-grid_vertical"
      }, React.createElement(Card, {
        id: "ExampleCard",
        filter: (!isEmpty || this.state.isFiltering) && React.createElement(CardFilter, {
          onChange: this.handleFilterChange
        }),
        headerActions: !isEmpty && React.createElement(Button, {
          label: "Delete All Items",
          onClick: this.handleDeleteAllItems
        }),
        heading: "Releated Items",
        icon: React.createElement(Icon, {
          category: "standard",
          name: "document",
          size: "small"
        }),
        empty: isEmpty ? React.createElement(CardEmpty, {
          heading: "No Related Items"
        }, React.createElement(Button, {
          label: "Add Item",
          onClick: this.handleAddItem
        })) : null
      }, React.createElement(DataTable, {
        items: this.state.items,
        id: "DataTableExample-1",
        bordered: true
      }, React.createElement(DataTableColumn, {
        label: "Opportunity Name",
        property: "name",
        truncate: true
      })))));
    }
  }]);

  return Example;
}(React.Component);

Object.defineProperty(Example, "displayName", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: 'CardExample'
});
export default Example; // export is replaced with `ReactDOM.render(<Example />, mountNode);` at runtime
//# sourceMappingURL=related-list-with-table.js.map