import React from 'react';
import { storiesOf } from '@storybook/react';
import { action } from '@storybook/addon-actions';
import IconSettings from '../../icon-settings';
import { DATA_TABLE } from '../../../utilities/constants';
import Advanced from '../__examples__/advanced';
import AdvancedSingleSelect from '../__examples__/advanced-single-select';
import AdvancedSingleSelectFixedHeader from '../__examples__/advanced-single-select-fixed-header';
import Basic from '../__examples__/basic';
import BasicFixedLayout from '../__examples__/basic-fixed-layout';
import FixedHeader from '../__examples__/fixed-header';
storiesOf(DATA_TABLE, module).addDecorator(function (getStory) {
  return React.createElement("div", {
    className: "slds-p-around_medium"
  }, React.createElement(IconSettings, {
    iconPath: "/assets/icons"
  }, getStory()));
}).add('Basic (Fluid Layout)', function () {
  return React.createElement(Basic, null);
}).add('Basic (Fixed Layout)', function () {
  return React.createElement(BasicFixedLayout, null);
}).add('Advanced (Fixed Layout)', function () {
  return React.createElement(Advanced, {
    log: action
  });
}).add('Advanced Single Select (Fixed Layout)', function () {
  return React.createElement(AdvancedSingleSelect, {
    log: action
  });
}).add('Advanced Single Select (Fixed Header)', function () {
  return React.createElement(AdvancedSingleSelectFixedHeader, {
    log: action
  });
}).add('Fixed Header', function () {
  return React.createElement(FixedHeader, null);
});
//# sourceMappingURL=storybook-stories.js.map